// Folgende Zeile in der Final-Version auskommentieren:
// #define NDEBUG
// Muss _vor_ dem #include von assert stehen!

#include <cassert>
using namespace std;
// oder assert.h nehmen

// assert statt Exceptions einsetzen, um _logische_ Fehler
// zu finden (aber keine Laufzeitfehler, z.B. Speichermangel).
// Vor- und Nachbedingungen mit assert checken,
// Ausnahme ggf.: externe Aufrufe einer Klassenbibliothek

// assert(bool) ist ein Makro, das nur dann etwas tut,
// wenn ein Makro namens NDEBUG nicht (!) definiert ist
// -> langsamere Debug-Version von Programm zum Betatest.

int fakultaet (int x)
{
    assert (x>=1);
    // falls nicht erfllt: Abbruch, Ausgabe von Dateiname und Zeile
    return (x>1) ? x*fakultaet(x-1) : 1 ;
}

void grosseFunktion (char s[], int y)
{
    assert (s != 0); // Nullzeiger?
    assert (s[0] != 0); // berhaupt Zeichen in String?

    // falsche Verwendung: Nebeneffekt
    int z;
    assert ((z=y/3, z>42));
    int a=z;
}

int main()
{
    int a = fakultaet(42);
    //int b = fakultaet(-13); // Ooops!

    grosseFunktion("abc", 340);
    char *t = 0;
    //grosseFunktion(t, 340); // Ooops!
    //grosseFunktion("", 340); // Ooops!
    //grosseFunktion("abc", 0); // Ooops!
    return 0;
}
